(defn fib [n]
  (cond
    (= n 0) 0
    (= n 1) 1
    :else (+ (fib (- n 1))
             (fib (- n 2)))))

(defn fib-tail [n]
  (letfn [(fib [current next n]  ; idea: fib [fib(n-k) fib(n-k+1) k]
            (if (zero? n)
              current
              (fib next (+ current  next) (dec n))))]
    (fib 0N 1N n)))



(defn fib-recur [n]
  (loop [current 0N, next 1N, num n]  
    (if (zero? num)
      current
      (recur next (+ current  next) (dec num)))))
