(require '[clojure.core.reducers :as r])

;; (ns sum.core
;;   (:require [clojure.core.reducers :as r]))


(defn recursive-sum [numbers]
  (if (empty? numbers)
    0
    (+ (first numbers) (recursive-sum (rest numbers)))))

(defn recur-sum [numbers]
  (loop [ acc 0, list numbers ]
    (if (empty? list)
      acc
      (recur (+ acc (first list)) (rest list)))))

(defn parallel-sum [numbers]
  (r/fold + numbers))

(def numbers (into [] (range 0 10000000)))

